package com.bcxin.tenant.open.dubbo.reader.providers.transfers;

import com.bcxin.tenant.open.document.domains.documents.RdCompanyDocument;
import com.bcxin.tenant.open.document.domains.documents.RdDeviceDocument;
import com.bcxin.tenant.open.document.domains.documents.RdEmployeeDocument;
import com.bcxin.tenant.open.document.domains.documents.RdSecurityStationDocument;
import com.bcxin.tenant.open.infrastructures.enums.DeskType;
import com.bcxin.tenant.open.jdks.requests.DeviceSearchRequest;
import com.bcxin.tenant.open.jdks.requests.EmployeeSearchRequest;
import com.bcxin.tenant.open.jdks.requests.EmployeeWriterRequest;
import com.bcxin.tenant.open.jdks.requests.SecurityStationReaderRequest;
import com.bcxin.tenant.open.jdks.responses.*;
import com.redis.om.spring.search.stream.EntityStream;

import java.util.Collection;

public interface DataTransfer {

    EmployeeDetailResponse translate(DeskType deskType, RdEmployeeDocument document, EntityStream entityStream);

    Collection<EmployeeOverviewResponse> translate(Collection<DeskType> deskTypes,EmployeeSearchRequest.SearchModel model,
                                                   Collection<RdEmployeeDocument> documents,
                                                   EntityStream entityStream);

    CompanyDetailResponse translate(RdCompanyDocument companyDocument,Integer countOfExamSiteRooms);

    SecurityStationDetailResponse translate(EntityStream entityStream,RdSecurityStationDocument document);

    Collection<SecurityStationOverviewReaderResponse> translate2Stations(
            SecurityStationReaderRequest.SearchModel mode,
            Collection<RdSecurityStationDocument> documents);

    Collection<DeviceResponse> translate(Collection<RdDeviceDocument> documents, boolean isSecurityResourceRequest);

    DeviceResponse translate(RdDeviceDocument document, boolean isSecurityResourceRequest);
}
